<?php

require_once 'base/GpeparamorgEntityBase.php';


/**
 * GpeparamorgEntity.
 *
 * @package Entity
 * @author  alessandrobartels 05/07/2011
 *
 */
class GpeparamorgEntity extends GpeParamorgEntityBase
{

    const IDESTRUTURA_LEGAL     = 'LEGAL';
    const IDESTRUTURA_GERENCIAL = 'GERENCIAL';

    private $_parametro;

    /**
     * Enter description here ...
     *
     * @param integer $nrOrg Numero da Org. Trabalho.
     *
     * @throws Exception Propaga Excecao.
     *
     * @return null | GpeparamorgEntity
     */
    public function retornaParamOrganizacao($nrOrg) {
        try {
            $this->_parametro = Gpeparamorg::retornaParamOrganizacao($nrOrg);
            if (is_object($this->_parametro) === true) {
                 return true;
            } else {
                 return false;
            }
            //$resultado = Gpeparamorg::retornaParamOrganizacao($nrOrg);
            //return $resultado;
        } catch (Exception $e) {
            throw $e;
        }
    }


    public function retornaNrOrgPadrao(){
        if (is_object($this->_parametro) === true) {
            return $this->_parametro->getNrorgpadrao();
        } else {
            tk_warning('GPEPARAMORG - Organizacao nao parametrizada.');
        }
    }


    /**
     * Retorna o numero de estrutura legal
     *
     * @param
     *
     * @return integer | null
     *
     * @author alessandrobartels - 30/03/12
     */
    private function _retornaTipoEstrutura($idEstrutura){
        if (is_object($this->_parametro) === true) {
            if (strtoupper($idEstrutura) === self::IDESTRUTURA_LEGAL) {
                return (int)$this->_parametro->getNrtpestrutlegal();
            } elseif (strtoupper($idEstrutura) === self::IDESTRUTURA_GERENCIAL) {
                return (int)$this->_parametro->getNrtpestrutgeren();
            } else {
                tk_warning('Parametro de identificador de estrutura nao definido.');
                return null;
            }
        }
    }


    public function retornaTipoEstruturaLegal(){
        return $this->_retornaTipoEstrutura(self::IDESTRUTURA_LEGAL);
    }


    public function retornaTipoEstruturaGerencial(){
        return $this->_retornaTipoEstrutura(self::IDESTRUTURA_GERENCIAL);
    }

}